#pragma once
#include <vector>
#include "ParamFloat.h"

namespace ffgl
{

class ParamOption : public ParamFloat
{
public:
	struct Option
	{
		std::string name;
		float value;
	};

	ParamOption( const std::string& name, FFUInt32 defaultIndex = 0U );
	ParamOption( const std::string& name, const std::string& uniformName, FFUInt32 defaultIndex = 0U );
	ParamOption( const std::string& name, std::vector< Option > options, FFUInt32 defaultIndex = 0U );
	ParamOption( const std::string& name, const std::string& uniformName, std::vector< Option > options, FFUInt32 defaultIndex = 0U );

	~ParamOption();

	//void Reset() override;
	const std::string& GetDisplay() const override;
	//FFMixed GetMixedDefault() const override;
	//FFMixed GetMixedValue() const override;
	FFResult SetMixedValue( FFMixed mixed ) override;

	void AddOption( Option option );
	FFUInt32 GetNumOptions() const;
	const Option* GetOption( FFUInt32 index ) const;
	const char* GetOptionName( FFUInt32 index ) const;
	FFResult GetOptionValue( FFUInt32 index, float& outValue ) const;

	FFUInt32 GetDefaultIndex() const;
	FFUInt32 GetIndex() const;
	FFResult SetIndex( FFUInt32 index );

	float GetRealValue() const;

	bool IsCurrentOption( const std::string& optionName ) const;

protected:
	std::vector< Option > options;
};

}//End namespace ffgl
